#!/usr/bin/env python
"""
Setup file for Ca-Python using distutils package.
Python2.4 or later should be used.

Version Info:
  $Id: setup.py,v 1.20 2009/02/11 06:50:24 noboru Exp noboru $
  $Revision: 1.20 $
  $Author: noboru $
  $Log: setup.py,v $
  Revision 1.20  2009/02/11 06:50:24  noboru
  *** empty log message ***

  Revision 1.16.1.2  2008/04/02 22:50:04  noboru
  *** empty log message ***

  Revision 1.16.1.1  2008/02/03 00:42:30  noboru
  use platform.uname to identify the system arch.

  Revision 1.16  2008/01/29 13:08:04  noboru
  *** empty log message ***

  Revision 1.15.2.1  2008/01/29 00:33:00  noboru
  *** empty log message ***

  Revision 1.15.1.7  2007/10/13 00:30:40  noboru
  *** empty log message ***

  Revision 1.15.1.6  2007/10/13 00:17:31  noboru
  *** empty log message ***

  Revision 1.15.1.5  2007/09/28 12:31:50  noboru
  change from ca_get_host_name to ca_host_name in get_info function.

  Revision 1.15.1.4  2007/09/19 12:36:47  noboru
  autoGIL is not compatible with Tkinter nor wxPython.
  Code realted to autoGIL is removed.

  Revision 1.15.1.3  2007/08/30 02:28:50  noboru
  *** empty log message ***

  Revision 1.15.1.2  2007/07/09 14:30:59  noboru
  *** empty log message ***

  Revision 1.15.1.1  2007/07/05 14:02:05  noboru
  *** empty log message ***

  Revision 1.15  2007/07/04 14:26:01  noboru
  remove py_ca_lock altogather.

  Revision 1.14  2007/07/02 23:07:32  noboru
  *** empty log message ***

  Revision 1.13  2007/05/26 00:50:05  noboru
  *** empty log message ***

  Revision 1.12  2007/05/09 01:26:47  noboru
  remove redundant  mutex_lock

  Revision 1.11  2007/05/07 00:49:00  noboru
  *** empty log message ***

  Revision 1.10  2007/05/03 01:19:22  noboru
  change default optimization level to 0

  Revision 1.9  2007/04/28 23:20:49  noboru
  Add version constant. Currently it shows revision number of _ca314.cpp

Revision 1.8  2007/04/16 02:51:33  noboru
*** empty log message ***

Revision 1.6.1.7  2007/04/14 05:55:00  noboru
still CaSimple.py crashes

Revision 1.6.1.6  2007/04/13 09:20:32  noboru
problem on array put was fixed

Revision 1.6.1.5  2007/04/11 11:15:06  noboru
fixed long-array-put bug

Revision 1.6.1.4  2007/04/11 07:09:07  noboru
lock added to _ca_frame

Revision 1.6.1.3  2007/04/02 04:48:05  noboru
frame info are now stored in Python dictionary.

Revision 1.6.1.2  2007/03/28 03:22:04  noboru
adjust environment setup parameters.

Revision 1.6.1.1  2007/03/27 22:45:23  noboru
gen_caerrpy.c is added.

Revision 1.6  2007/03/20 11:48:56  noboru
Add RCS keywords to setup.py

"""

import os,platform
try:
    UNAME=platform.uname()[0]
except:
    UNAME="Unknowon"

# use Environmet Variable first and then try config files.
if os.environ.has_key("EPICS_ROOT"):
    EPICSROOT=os.environ["EPICS_ROOT"]
    EPICSBASE=os.path.join(EPICSROOT,"base")
    EPICSEXT=os.path.join(EPICSROOT,"extensions")
else:
    EPICSROOT=None

if os.environ.has_key("EPICS_BASE"):
    EPICSBASE=os.environ["EPICS_BASE"]
    if not EPICSROOT:
        EPICSROOT=os.path.dirname(EPICSBASE)
        EPICSEXT=os.path.join(EPICSROOT,"extensions")
else:
    EPICSBASE=None

if os.environ.has_key("EPICS_EXTENSIONS"):
    EPICSEXT=os.environ["EPICS_EXTENSIONS"]
    if not EPICSROOT:
        EPICSROOT=os.path.dirname(EPICSEXT)
    if not EPICSBASE:
        EPICSBASE=os.path.join(EPICSROOT,"base")
else:
    EPICSEXT=None

if os.environ.has_key("TK_INC"):
    TKINC=os.environ["TK_INC"]
else:
    TKINC="/usr/local/include"

## Tk include/library path
if os.environ.has_key("TK_LIB"):
    TKLIB=os.environ["TK_LIB"]
else:
    TKLIB="/usr/local"
# read config file if any
libraries=None
try:
    if (UNAME == "Darwin"):
        from EPICS_config_Darwin import *
    elif(UNAME =="Linux"):
        from EPICS_config_Linux import *
    elif(UNAME =="Windows"):
        from EPICS_config_Win32 import *
        #UNAME="WIN32"
    else:
        from EPICS_config import *
except ImportError,m:
    print "No config file. Retain Environment variable setting."

assert(EPICSROOT)
assert(EPICSBASE)
assert(EPICSEXT)

if (HOSTARCH==None):
    HOSTARCH=os.popen(os.path.join(EPICSBASE,"startup/EpicsHostArch.pl")).read()

assert(HOSTARCH)
assert(TKINC)
assert(TKLIB)

# choose _ca source
#CA_SOURCE="_ca.c"  # for NON-threaded version
CA_SOURCE="_ca314.cpp" # for threaded version.

## start normal setup.
from distutils.core import setup,Extension
rev="$Revision: 1.20.1.rc1 $"

if (libraries==None):
    if UNAME.lower() == "alpha":
        libraries=["ca","As","Com"]
    else:
        libraries=["ca","asHost","Com","tk","tcl",]
#
setup(name="PythonCA",
      version=rev[11:-2],
      author="Noboru Yamamoto, KEK, JAPAN",
      author_email = "Noboru.YAMAMOTO@kek.jp",
      description="EPICS CA library interface module",
      long_description="""
      EPICS CA library interface module (KEK,Japan)
      """,
      url="http://www-acc.kek.jp/EPICS_Gr/products.html",
      download_url="http://www-acc.kek.jp/EPICS_Gr/products.html",
      classifiers=['Programming Language:: C, Python',
                   'Topic :: EPICS CA',
                   'Topic :: Controls'
                   ],
      py_modules=["ca", "caError", "cadefs","_ca_kek"],
      ext_modules=[Extension("_ca",[CA_SOURCE],
                             include_dirs=[os.path.join(TKINC, "include"), 
                                           os.path.join(TKINC),
                                           os.path.join(TCLINC, "include"), 
                                           os.path.join(TCLINC),
                                           os.path.join(EPICSBASE,"include"),
                                           os.path.join(EPICSBASE,"include/os",UNAME),
                                           os.path.join(EPICSBASE,"include/os"),
					   os.path.join("/usr/X11R6","include")],
                             define_macros=[("PYCA_VERSION","\"%s\""%rev[11:-2]),
                                            ("WITH_TK", None),
                                            ("UNIX", None),
                                            (UNAME, None)],
                             undef_macros="",
                             libraries=libraries,
                             library_dirs=[os.path.join(EPICSBASE,"lib",HOSTARCH),
                                           os.path.join(TKLIB,""),
                                           os.path.join(TCLLIB,""),
                                           ],
                             extra_compile_args=["-O0"], # Can we set it to -O1 ?
                             runtime_library_dirs=[os.path.join(EPICSBASE,"lib",HOSTARCH),],
                             ),
                   ],
      )


setup(name="cas",
      version=rev[11:-2],
      author="Tatsuro Nakamur, KEK, JAPAN",
      author_email = "Tatsuro.nakamura@kek.jp",
      description="EPICS CA library interface module",
      long_description="""
      Simple EPICS CA library interface module (KEK,Japan)
      """,
      url="http://www-acc.kek.jp/EPICS_Gr/products.html",
      download_url="http://www-acc.kek.jp/EPICS_Gr/products.html",
      classifiers=['Programming Language:: Python',
                   'Topic :: EPICS CA',
                   'Topic :: Controls'
                   ],
      package_dir={"":"cas"},
      py_modules=["cas","xca"],
      )
